//#define NU32_STANDALONE  // uncomment if program is standalone, not bootloaded
#include "NU32.h"          // peripheral.h, config bits, constants, funcs for startup and UART

void __ISR(_EXTERNAL_0_VECTOR, IPL2SOFT) Ext0ISR(void) { // step 1: the ISR
  LATACLR = 0x30;                 // clear RA4 and RA5 low (LED1 and LED2 on)
  _CP0_SET_COUNT(0);
  while(_CP0_GET_COUNT() < 10000000) {
      ;                           // delay for 10 M core ticks, 0.25 s
  }
  LATASET = 0x30;                 // set pins RA4 and RA5 high (LED1 and LED2 off)
  IFS0CLR = 1 << 3;               // clear interrupt flag IFS0<3>
}

void main(void) {
  NU32_Startup(); // cache on, min flash wait, interrupts on, LED/button init, UART init
  __builtin_disable_interrupts(); // step 2: disable interrupts
  INTCONCLR = 0x1;                // step 3: INT0 triggers on falling edge
  IPC0CLR = 0x1F << 24;           // step 4: clear the 5 pri and subpri bits
  IPC0 |= 9 << 24;                // step 4: set priority to 2, subpriority to 1
  IFS0bits.INT0IF = 0;            // step 5: clear the int flag, or IFS0CLR=1<<3
  IEC0SET = 1 << 3;               // step 6: enable INT0 by setting IEC0<3>
  __builtin_enable_interrupts();  // step 7: enable interrupts
  while(1) {
      ; // do nothing, loop forever
  }
}
